
const db = require('../models');
const FileDBApi = require('./file');
const crypto = require('crypto');
const Utils = require('../utils');



const Sequelize = db.Sequelize;
const Op = Sequelize.Op;

module.exports = class InvoicesDBApi {
    

    
    static async create(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const invoices = await db.invoices.create(
            {
                id: data.id || undefined,
        
        invoice_number: data.invoice_number
        ||
        null
            ,
            
        invoice_type: data.invoice_type
        ||
        null
            ,
            
        status: data.status
        ||
        null
            ,
            
        issue_date: data.issue_date
        ||
        null
            ,
            
        due_date: data.due_date
        ||
        null
            ,
            
        currency_code: data.currency_code
        ||
        null
            ,
            
        exchange_rate: data.exchange_rate
        ||
        null
            ,
            
        subtotal_amount: data.subtotal_amount
        ||
        null
            ,
            
        tax_amount: data.tax_amount
        ||
        null
            ,
            
        discount_amount: data.discount_amount
        ||
        null
            ,
            
        total_amount: data.total_amount
        ||
        null
            ,
            
        amount_paid: data.amount_paid
        ||
        null
            ,
            
        balance_due: data.balance_due
        ||
        null
            ,
            
        customer_notes: data.customer_notes
        ||
        null
            ,
            
        terms_and_conditions: data.terms_and_conditions
        ||
        null
            ,
            
            importHash: data.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
    },
        { transaction },
    );

        
        await invoices.setOrganization(currentUser.organization.id || null, {
            transaction,
        });
        
        await invoices.setCustomer( data.customer || null, {
            transaction,
        });
        
        await invoices.setQuote( data.quote || null, {
            transaction,
        });
        

        
        await invoices.setInvoice_lines(data.invoice_lines || [], {
            transaction,
        });
        

        
        await FileDBApi.replaceRelationFiles(
            {
                belongsTo: db.invoices.getTableName(),
                belongsToColumn: 'attachments',
                belongsToId: invoices.id,
            },
            data.attachments,
            options,
        );
        

        return invoices;
    }
    

    static async bulkImport(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        // Prepare data - wrapping individual data transformations in a map() method
        const invoicesData = data.map((item, index) => ({
                id: item.id || undefined,
                
                invoice_number: item.invoice_number
            ||
            null
            ,
            
                invoice_type: item.invoice_type
            ||
            null
            ,
            
                status: item.status
            ||
            null
            ,
            
                issue_date: item.issue_date
            ||
            null
            ,
            
                due_date: item.due_date
            ||
            null
            ,
            
                currency_code: item.currency_code
            ||
            null
            ,
            
                exchange_rate: item.exchange_rate
            ||
            null
            ,
            
                subtotal_amount: item.subtotal_amount
            ||
            null
            ,
            
                tax_amount: item.tax_amount
            ||
            null
            ,
            
                discount_amount: item.discount_amount
            ||
            null
            ,
            
                total_amount: item.total_amount
            ||
            null
            ,
            
                amount_paid: item.amount_paid
            ||
            null
            ,
            
                balance_due: item.balance_due
            ||
            null
            ,
            
                customer_notes: item.customer_notes
            ||
            null
            ,
            
                terms_and_conditions: item.terms_and_conditions
            ||
            null
            ,
            
            importHash: item.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
            createdAt: new Date(Date.now() + index * 1000),
    }));

        // Bulk create items
        const invoices = await db.invoices.bulkCreate(invoicesData, { transaction });

        // For each item created, replace relation files
        
        for (let i = 0; i < invoices.length; i++) {
            await FileDBApi.replaceRelationFiles(
                {
                    belongsTo: db.invoices.getTableName(),
                    belongsToColumn: 'attachments',
                    belongsToId: invoices[i].id,
                },
                data[i].attachments,
                options,
            );
        }
        

        return invoices;
    }

    static async update(id, data,  options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;
        const globalAccess = currentUser.app_role?.globalAccess;

        const invoices = await db.invoices.findByPk(id, {}, {transaction});


        

        const updatePayload = {};
        
        if (data.invoice_number !== undefined) updatePayload.invoice_number = data.invoice_number;
        
        
        if (data.invoice_type !== undefined) updatePayload.invoice_type = data.invoice_type;
        
        
        if (data.status !== undefined) updatePayload.status = data.status;
        
        
        if (data.issue_date !== undefined) updatePayload.issue_date = data.issue_date;
        
        
        if (data.due_date !== undefined) updatePayload.due_date = data.due_date;
        
        
        if (data.currency_code !== undefined) updatePayload.currency_code = data.currency_code;
        
        
        if (data.exchange_rate !== undefined) updatePayload.exchange_rate = data.exchange_rate;
        
        
        if (data.subtotal_amount !== undefined) updatePayload.subtotal_amount = data.subtotal_amount;
        
        
        if (data.tax_amount !== undefined) updatePayload.tax_amount = data.tax_amount;
        
        
        if (data.discount_amount !== undefined) updatePayload.discount_amount = data.discount_amount;
        
        
        if (data.total_amount !== undefined) updatePayload.total_amount = data.total_amount;
        
        
        if (data.amount_paid !== undefined) updatePayload.amount_paid = data.amount_paid;
        
        
        if (data.balance_due !== undefined) updatePayload.balance_due = data.balance_due;
        
        
        if (data.customer_notes !== undefined) updatePayload.customer_notes = data.customer_notes;
        
        
        if (data.terms_and_conditions !== undefined) updatePayload.terms_and_conditions = data.terms_and_conditions;
        
        
        updatePayload.updatedById = currentUser.id;

        await invoices.update(updatePayload, {transaction});

        
        
        if (data.organization !== undefined) {
            await invoices.setOrganization(
              
              (globalAccess ? data.organization : currentUser.organization.id),
              
              { transaction }
            );
        }
        
        if (data.customer !== undefined) {
            await invoices.setCustomer(
              
              data.customer,
              
              { transaction }
            );
        }
        
        if (data.quote !== undefined) {
            await invoices.setQuote(
              
              data.quote,
              
              { transaction }
            );
        }
        

        
        
        if (data.invoice_lines !== undefined) {
            await invoices.setInvoice_lines(data.invoice_lines, { transaction });
        }
        

        
        await FileDBApi.replaceRelationFiles(
            {
                belongsTo: db.invoices.getTableName(),
                belongsToColumn: 'attachments',
                belongsToId: invoices.id,
            },
            data.attachments,
            options,
        );
        

        return invoices;
    }

    static async deleteByIds(ids, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const invoices = await db.invoices.findAll({
            where: {
                id: {
                    [Op.in]: ids,
                },
            },
            transaction,
        });

        await db.sequelize.transaction(async (transaction) => {
            for (const record of invoices) {
                await record.update(
                    {deletedBy: currentUser.id},
                    {transaction}
                );
            }
            for (const record of invoices) {
                await record.destroy({transaction});
            }
        });


        return invoices;
    }

    static async remove(id, options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;

        const invoices = await db.invoices.findByPk(id, options);

        await invoices.update({
            deletedBy: currentUser.id
        }, {
            transaction,
        });

        await invoices.destroy({
            transaction
        });

        return invoices;
    }

    static async findBy(where, options) {
        const transaction = (options && options.transaction) || undefined;

        const invoices = await db.invoices.findOne(
            { where },
            { transaction },
        );

        if (!invoices) {
            return invoices;
        }

        const output = invoices.get({plain: true});

        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        output.invoice_lines_invoice = await invoices.getInvoice_lines_invoice({
            transaction
        });
        
        
        output.payments_invoice = await invoices.getPayments_invoice({
            transaction
        });
        
        
        output.receipts_invoice = await invoices.getReceipts_invoice({
            transaction
        });
        
        
        
        
        
        
        
        
        output.efris_submissions_invoice = await invoices.getEfris_submissions_invoice({
            transaction
        });
        
        
        
        
        output.organization = await invoices.getOrganization({
            transaction
        });
        
        
        output.customer = await invoices.getCustomer({
            transaction
        });
        
        
        output.quote = await invoices.getQuote({
            transaction
        });
        
        
        output.attachments = await invoices.getAttachments({
            transaction
        });
        
        
        output.invoice_lines = await invoices.getInvoice_lines({
            transaction
        });
        
        

        return output;
    }

    static async findAll(
          filter,
           globalAccess,  options
        ) {
        const limit = filter.limit || 0;
        let offset = 0;
        let where = {};
        const currentPage = +filter.page;

        
        const user = (options && options.currentUser) || null;
        const userOrganizations = (user && user.organizations?.id) || null;
        

        
        if (userOrganizations) {
            if (options?.currentUser?.organizationsId) {
                where.organizationsId = options.currentUser.organizationsId;
            }
        }
        

        offset = currentPage * limit;

        const orderBy = null;

    const transaction = (options && options.transaction) || undefined;

    let include = [

      {
        model: db.organizations,
        as: 'organization',
        
      },

      {
        model: db.contacts,
        as: 'customer',
        
        where: filter.customer ? {
          [Op.or]: [
            { id: { [Op.in]: filter.customer.split('|').map(term => Utils.uuid(term)) } },
            {
              display_name: {
                [Op.or]: filter.customer.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },

      {
        model: db.quotes,
        as: 'quote',
        
        where: filter.quote ? {
          [Op.or]: [
            { id: { [Op.in]: filter.quote.split('|').map(term => Utils.uuid(term)) } },
            {
              quote_number: {
                [Op.or]: filter.quote.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },


      {
        model: db.invoice_lines,
        as: 'invoice_lines',
        required: false,
      },


      {
        model: db.file,
        as: 'attachments',
      },

    ];

        if (filter) {
            if (filter.id) {
                where = {
                    ...where,
                    ['id']: Utils.uuid(filter.id),
                };
            }

            
            if (filter.invoice_number) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'invoices',
                        'invoice_number',
                        filter.invoice_number,
                    ),
                };
            }
            
            if (filter.currency_code) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'invoices',
                        'currency_code',
                        filter.currency_code,
                    ),
                };
            }
            
            if (filter.customer_notes) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'invoices',
                        'customer_notes',
                        filter.customer_notes,
                    ),
                };
            }
            
            if (filter.terms_and_conditions) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'invoices',
                        'terms_and_conditions',
                        filter.terms_and_conditions,
                    ),
                };
            }
            

            
            

            
            if (filter.issue_dateRange) {
                const [start, end] = filter.issue_dateRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    issue_date: {
                    ...where.issue_date,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    issue_date: {
                    ...where.issue_date,
                            [Op.lte]: end,
                    },
                };
                }
            }
            
            if (filter.due_dateRange) {
                const [start, end] = filter.due_dateRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    due_date: {
                    ...where.due_date,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    due_date: {
                    ...where.due_date,
                            [Op.lte]: end,
                    },
                };
                }
            }
            
            if (filter.exchange_rateRange) {
                const [start, end] = filter.exchange_rateRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    exchange_rate: {
                    ...where.exchange_rate,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    exchange_rate: {
                    ...where.exchange_rate,
                            [Op.lte]: end,
                    },
                };
                }
            }
            
            if (filter.subtotal_amountRange) {
                const [start, end] = filter.subtotal_amountRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    subtotal_amount: {
                    ...where.subtotal_amount,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    subtotal_amount: {
                    ...where.subtotal_amount,
                            [Op.lte]: end,
                    },
                };
                }
            }
            
            if (filter.tax_amountRange) {
                const [start, end] = filter.tax_amountRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    tax_amount: {
                    ...where.tax_amount,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    tax_amount: {
                    ...where.tax_amount,
                            [Op.lte]: end,
                    },
                };
                }
            }
            
            if (filter.discount_amountRange) {
                const [start, end] = filter.discount_amountRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    discount_amount: {
                    ...where.discount_amount,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    discount_amount: {
                    ...where.discount_amount,
                            [Op.lte]: end,
                    },
                };
                }
            }
            
            if (filter.total_amountRange) {
                const [start, end] = filter.total_amountRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    total_amount: {
                    ...where.total_amount,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    total_amount: {
                    ...where.total_amount,
                            [Op.lte]: end,
                    },
                };
                }
            }
            
            if (filter.amount_paidRange) {
                const [start, end] = filter.amount_paidRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    amount_paid: {
                    ...where.amount_paid,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    amount_paid: {
                    ...where.amount_paid,
                            [Op.lte]: end,
                    },
                };
                }
            }
            
            if (filter.balance_dueRange) {
                const [start, end] = filter.balance_dueRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    balance_due: {
                    ...where.balance_due,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    balance_due: {
                    ...where.balance_due,
                            [Op.lte]: end,
                    },
                };
                }
            }
            

            if (filter.active !== undefined) {
                where = {
                    ...where,
                    active: filter.active === true || filter.active === 'true'
                };
            }

            
            if (filter.invoice_type) {
                where = {
                    ...where,
                invoice_type: filter.invoice_type,
            };
            }
            
            if (filter.status) {
                where = {
                    ...where,
                status: filter.status,
            };
            }
            


      
      if (filter.organization) {
        const listItems = filter.organization.split('|').map(item => {
          return  Utils.uuid(item)
        });

        where = {
          ...where,
          organizationId: {[Op.or]: listItems}
        };
      }
      

      

      


      if (filter.invoice_lines) {
        const searchTerms = filter.invoice_lines.split('|');

        include = [
          {
            model: db.invoice_lines,
            as: 'invoice_lines_filter',
            required: searchTerms.length > 0,
            where: searchTerms.length > 0 ? {
              [Op.or]: [
                { id: { [Op.in]: searchTerms.map(term => Utils.uuid(term)) } },
                { 
                  line_description: {
                    [Op.or]: searchTerms.map(term => ({ [Op.iLike]: `%${term}%` }))
                  }
                }
              ]
            } : undefined
          },
          ...include,
        ]
      }


            if (filter.createdAtRange) {
                const [start, end] = filter.createdAtRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.gte]: start,
                        },
                    };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.lte]: end,
                        },
                    };
                }
            }
        }
        

        
        if (globalAccess) {
            delete where.organizationsId;
        }
        

        const queryOptions = {
            where,
            include,
            distinct: true,
            order: filter.field && filter.sort
                ? [[filter.field, filter.sort]]
                : [['createdAt', 'desc']],
            transaction: options?.transaction,
            logging: console.log
        };

        if (!options?.countOnly) {
            queryOptions.limit = limit ? Number(limit) : undefined;
            queryOptions.offset = offset ? Number(offset) : undefined;
        }

        try {
            const { rows, count } = await db.invoices.findAndCountAll(queryOptions);

            return {
                rows: options?.countOnly ? [] : rows,
                count: count
            };
        } catch (error) {
            console.error('Error executing query:', error);
            throw error;
        }
    }

    static async findAllAutocomplete(query, limit, offset,  globalAccess, organizationId,) {
        let where = {};
        
        
        if (!globalAccess && organizationId) {
            where.organizationId = organizationId;
        }
        

        if (query) {
            where = {
                [Op.or]: [
                    { ['id']: Utils.uuid(query) },
                    Utils.ilike(
                        'invoices',
                        'invoice_number',
                        query,
                    ),
                ],
            };
        }

        const records = await db.invoices.findAll({
            attributes: [ 'id', 'invoice_number' ],
            where,
            limit: limit ? Number(limit) : undefined,
            offset: offset ? Number(offset) : undefined,
            orderBy: [['invoice_number', 'ASC']],
        });

        return records.map((record) => ({
            id: record.id,
            label: record.invoice_number,
        }));
    }

    
};

